/**
switch-lang.js
MOTOROLA_CONFIDENTIAL_PROPRIETARY
------------------------------------------------------------------------------------------
                        Motorola Confidential Proprietary
                Copyright 2009 Motorola, Inc. All Rights Reserved.

Internal Revision History:

Modification Tracking

        Author                Date           CR         Description of Changes
-------------------------   ------------ ---------- ----------------------------------------
     atila.andrade           2009-03-24       -         Initial Version
**/
// Default language
DEFAULT_ID_LANGUAGE   = 'en';

// Put Flags and Scripts on the top page based on LANG.xml
// This way the language used is verified through 'id' parameter.
function importLangScript(langId, jsSrc, langName) {

    // an example of html tag for inserting (importing) the language table script
    // <script language="javascript" type="text/javascript" src="js_lang/en.js"></script>

    var BuildTime = _BuildTime.replace(/[^0-9]/g,"");

    var jsPath = '<script language="javascript" type="text/javascript" src="js_lang/' + jsSrc + '?t=' + BuildTime +'"></script>'
    $(jsPath).appendTo('#js-languages');

    // Create the prompt table object
    var result = promptTableToFunction(langId, langName);

    return result;
};

// Adding a flag based on language defined
// This way the language used is verified through 'id' parameter
function putFlag(langId, imgSrc, langName)
{
    // a example of html tag
    // <a href="#"><img src="en.gif" alt="English" title="English" id="en"/></a>

    var flag = '<a href="#"><img src="' + imgSrc + '" alt="' + langName + '" title="' + langName + '" id="' + langId + '" />'+ '&nbsp;'+ self[langId][multiLangText(langName, false)] +'</a>';
    $(flag).appendTo('#choose-language');

};

// Create a global variable with id language. Ex.: en = en();
function promptTableToFunction(id, langName)
{
    var funcId = new Function(id + "=" + id + "();");

    try
    {
        // Execute the function created before

        /*
         * var txt = {
         *
          // static html,
          "idrestartingmessagepart1" : "Cable Modem is restarting in",
          "idrestartingmessagepart2" : "seconds. You will be redirected to",
                ...
        }
        function en() {
        	return txt;
        };
         *
        */

        funcId();
    }
    // The language resource is not available...
    catch (e)
    {
        alert('[EMTA] Fatal error: the language table ' + langName + ' is not available.');
        return;
    }
    return true;
}

// Triggered when the user select a new idiom or when a page is loaded.
function chooseLanguage() {
	$('#choose-language a').click(function() {

		var currentId = $('#switch img').attr('id');
		var newIdiom = $(this).find('img').attr('id');

		if(currentId != newIdiom) {

			$('#container').hide();

			var valueCookie = $(this).find('img').attr('src') + '*' + $(this).find('img').attr('alt') + '*' + $(this).find('img').attr('id');
			createCookie('prefIdiom',valueCookie,365);
            
            setLanguage(valueCookie);
            
        	var parameters = {'selectlang': newIdiom};
        	$.ajax({url:"login/Lang.txt",
                	type: 'GET',
                	data: parameters,
                	dataType: "text",
                	error: function(){
                    	showErrorMessage('#form-config');
                	}
          		});
            //loadApp();
            
            if (run.load != null)
            {
                
                run.load();
                // For pages that contains tabs, select the first tab...
                firstTabsStyle();
            }
            
			$('#container').fadeIn(1000);
		} else {
			$('#choose-language').hide();
			return false;
		}

	});
};

// Separates the information read from cookie
function setLanguage(attributes) {

        var attr = attributes.split('*');

		/* CBN20110415 wilson add start : special hacking for IE browser*/
		if(attr[1] == "Current Language: English")
			attr[1] = "English";
		/* CBN20110415 wilson add end : special hacking for IE browser*/
		var newFlag = attr[0];
		var newAlt = attr[1];
		var newIdiom = attr[1];
		var newId = attr[2];

		$('#switch img').attr({
			src:newFlag,
			alt:newAlt,
			title:self[newId]['id_common_cur_lang'] + self[newId][multiLangText(newIdiom, false)],
			id:newId
		});
		$('#switch span').text(self[newId][multiLangText(newIdiom, false)]);
        updateContent();
};

// Translates or Updates the entire contents of a page
function updateContent(containerIdToTranslate) 
{
    var elementId = null;
    var dynamicSelector = ' .dynamic ';
    var dynamicValueSelector = ' .dynamicValue ';
    
    // Specific a place to translate. Used to translate just part of the page.
    if (containerIdToTranslate)
    {
        dynamicSelector = containerIdToTranslate + dynamicSelector;
        dynamicValueSelector = containerIdToTranslate + dynamicValueSelector;
    }
    
    try{
        
        $(dynamicSelector).each(function() {
            elementId = $(this).attr('id');
            $(this).html(getPromptTableValue(elementId));
        });
    }
    catch (e) {}

    try{
        $(dynamicValueSelector).each(function() {
            elementId = $(this).attr('id');
        $   (this).attr({value:getPromptTableValue(elementId)});
        });
    }
    catch (e) {}
};

// Function to verify if the default language tabble exists,
// aditionally the html structure for language indication
// will be loaded
function isDefaultLang()
{
    return importLangScript(DEFAULT_ID_LANGUAGE, DEFAULT_ID_LANGUAGE + '.js');
}


function showContentWithDefaultLanguage()
{
    var result = isDefaultLang();

    // If the default language can't be loaded
    if (result)
    {
        // Update the content page based on language defined
        updateContent();
    }

    return result;
}
